<template>
  <div>

    <!-- TITLE SECTION -->

    <div class="section-title text-center py-3 py-md-5">
      Cadastro de Equipamento em relação à Central {{ form.central_name }}
    </div>
    <b-button v-if="already_submit && submit_success" class="btn-block" @click="redirectToCentral" >Visualizar Central</b-button>
    <div class="submit-message">
      <b-alert v-if="already_submit && submit_success" :variant="sub_color" show fade>
        <h1 class="alert-heading">Sucesso!</h1>
        <p style="font-size: 2em">
          {{ submit_message_status }}
        </p>
      </b-alert>
    </div>
    <div class="submit-message">
      <b-alert v-if="already_submit && !submit_success" :variant="sub_color" :show="dismissCountDown" dismissible fade @dismissed="dismissCountDown=0" @dismiss-count-down="countDownChanged">
        <h1 class="alert-heading">Erro!</h1>
        <p style="font-size: 2em">
          {{ submit_message_status }}
        </p>
        <hr>
        <p style="font-size: 1.5em">
          {{ error_cause }}
        </p>
      </b-alert>
      
        
    </div>
    <b-form @submit="onSubmit">
      <!-- Equipment Identification Information -->

      <b-card v-if="!submit_success" class="my-3" >
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Identificação do equipamento
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações básicas sobre o equipamento
          </p>
        </div>
        <b-form-group id="equipment-name"
                      label="Nome:"
                      label-for="nome-do-equipamento">
          <b-form-input id="equipment-name"
                        v-model="form.equipment_name"
                        type="text"
                        required
                        placeholder="Nome do equipamento"/>
        </b-form-group>
        <b-form-group id="equipment-english-name"
                      label="Nome (em inglês):"
                      label-for="nome-do-equipamento-em-ingles">
          <b-form-input id="equipment-english-name"
                        v-model="form.equipment_english_name"
                        type="text"
                        required
                        placeholder="Nome do equipamento em inglês"/>
        </b-form-group>
        <b-form-group id="equipment-presentation"
                      label="Apresentação do Equipamento:"
                      label-for="apresentacao-do-equipamento">
          <b-form-input id="equipment-presentation"
                        v-model="form.equipment_presentation"
                        type="text"
                        required
                        placeholder="Breve descrição sobre a funcionalidade do equipamento"/>
        </b-form-group>
        <b-form-group id="equipment-brand"
                      label="Marca:"
                      label-for="marca-do-equipamento">
          <b-form-input id="equipment-brand"
                        v-model="form.equipment_brand"
                        type="text"
                        required
                        placeholder="Marca do equipamento"/>
        </b-form-group>
        <b-form-group id="equipment-model"
                      label="Modelo:"
                      label-for="modelo-do-equipamento">
          <b-form-input id="equipment-model"
                        v-model="form.equipment_model"
                        type="text"
                        required
                        placeholder="Modelo do equipamento"/>
        </b-form-group>
        <b-form-group id="equipment-patrimony-number"
                      label="Número de Patrimônio:"
                      label-for="numero-de-patrimonio-equipamento">
          <b-form-input id="equipment-patrimony-number"
                        v-model="form.equipment_patrimony_number"
                        type="number"
                        required
                        placeholder="Número de patrimônio do equipamento"/>
        </b-form-group>
        <b-form-group id="equipment-acquisition-year"
                      label="Ano de aquisição:"
                      label-for="ano-de-aquisição-equipamento">
          <b-form-input id="equipment-acquisition-year"
                        v-model="form.equipment_acquisition_year"
                        type="text"
                        required
                        placeholder="Ano de aquisição do equipamento"/>
        </b-form-group>
      </b-card>
      <b-card v-if="!submit_success" class="my-3" >
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Pesquisador Responsável
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações sobre o pesquisador responsável pelo equipamento.
          </p>
        </div>
        <b-form-group label="Unidade:"
                      label-for="units"
                      placeholder="Selecione a unidade do pesquisador responsável">
          <b-form-select v-model="form.researcher_unit" :options="unidades" class="mb-3">
            <template slot="first">
              <option :value="null" disabled>Selecione a unidade do pesquisador responsável</option>
            </template>
          </b-form-select>
        </b-form-group>
        <b-form-group id="researcher-usp-number"
                      label="Número USP do Pesquisador:"
                      label-for="numero-usp-pesquisador">
          <b-form-input id="researcher-usp-number"
                        v-model="form.researcher_USP_number"
                        type="number"
                        required
                        placeholder="Número USP do pesquisador responsável"/>
        </b-form-group>
        <b-form-group id="researcher-name"
                      label="Nome do Pesquisador:"
                      label-for="nome-do-pesquisador">
          <b-form-input id="researcher-name"
                        v-model="form.researcher_name"
                        type="text"
                        required
                        placeholder="Nome do pesquisador responsável"/>
        </b-form-group>
        <b-form-group id="researcher-email"
                      label="Email do Pesquisador:"
                      label-for="email-do-pesquisador">
          <b-form-input id="researcher-email"
                        v-model="form.researcher_email"
                        type="email"
                        required
                        placeholder="Email do pesquisador responsável"/>
        </b-form-group>
        <b-form-checkbox id="researcher-is-admin"
                         v-model="form.administrator_is_researcher"
                         plain>
          Pesquisador é administrador do equipamento
        </b-form-checkbox>
      </b-card>
      <b-card v-if="!form.administrator_is_researcher && !submit_success" class="my-3"> 
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Administrador
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações referentes ao administrador do equipamento
          </p>
        </div>
        <b-form-group label="Unidade do Administrador:"
                      label-for="units">
          <b-form-select v-model="form.administrator_unit" :options="unidades" class="mb-3">
            <template slot="first">
              <option :value="null" disabled>Selecione a unidade do administrador responsável</option>
            </template>
          </b-form-select>
        </b-form-group>
        <b-form-group id="administrator-usp-number"
                      label="Número USP:"
                      label-for="numero-usp-administrador">
          <b-form-input id="administrator-usp-number"
                        v-model="form.administrator_USP_number"
                        type="number"
                        optional
                        placeholder="Número USP do administrador do equipamento"/>
        </b-form-group>
        <b-form-group id="administrator-name"
                      label="Nome:"
                      label-for="nome-do-administrador">
          <b-form-input id="administrator-name"
                        v-model="form.administrator_name"
                        type="text"
                        optional
                        placeholder="Nome do administrador do equipamento"/>
        </b-form-group>
        <b-form-group id="administrator-email"
                      label="Email:"
                      label-for="email-do-administrador">
          <b-form-input id="administrator-email"
                        v-model="form.administrator_email"
                        type="email"
                        optional
                        placeholder="Email do administrador do equipamento"/>
        </b-form-group>
      </b-card>
      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Localização
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Local onde o equipamento se encontra
          </p>
        </div>
        <b-form-group label="Unidade:"
                      label-for="units">
          <b-form-select v-model="form.equipment_unit" :options="unidades" class="mb-3" @input="getAllDepartments">
            <template slot="first">
              <option :value="null" disabled>Selecione a unidade onde o equipamento se encontra</option>
            </template>
          </b-form-select>
        </b-form-group>
        <b-form-group label="Departamento:"
                      label-for="departamentos">
          <b-form-select v-model="form.equipment_department" :options="departamentos" class="mb-3">
            <template slot="first">
              <option :value="null" disabled>Selecione o departamento onde o equipamento se encontra</option>
            </template>
          </b-form-select>
        </b-form-group>
        <b-form-group id="equipment-address"
                      label="Endereço do Pesquisador:"
                      label-for="endereco-do-pesquisador">
          <b-form-input id="equipment-address"
                        v-model="form.equipment_address"
                        type="text"
                        required
                        placeholder="Logradouro"
                        class="my-3"/>
          <b-form-input id="equipment-address-number"
                        v-model="form.equipment_address_number"
                        type="number"
                        required
                        placeholder="Número"
                        class="my-3"/>
          <b-form-input id="equipment-address-complement"
                        v-model="form.equipment_address_complement"
                        type="text"
                        optional
                        placeholder="Complemento"
                        class="my-3"/>
        </b-form-group>
      </b-card>
      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Informações Gerais
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações gerais do equipamento
          </p>
        </div>
        <b-form-group id="equipment-description"
                      label="Descrição:"
                      label-for="descricao-do-equipamento">
          <b-form-textarea id="equipment-description"
                           v-model="form.equipment_description"
                           :rows="2"
                           :max-rows="4"
                           type="text"
                           required
                           placeholder="Descrição completa sobre o equipamento"
          />
        </b-form-group>
        <b-form-group id="equipment-english-description"
                      label="Descrição em Inglês:"
                      label-for="descricao-do-equipamento-em-ingles">
          <b-form-textarea id="equipment-english-description"
                           v-model="form.equipment_english_description"
                           :rows="2"
                           :max-rows="4"
                           type="text"
                           placeholder="Descrição completa sobre o equipamento em inglês"
                           required/>
        </b-form-group>
        <b-form-group id="equipment-services"
                      label="Serviços:"
                      label-for="servicos-do-equipamento">
          <b-form-textarea id="services"
                           v-model="form.equipment_offered_services"
                           :rows="2"
                           :max-rows="4"
                           optional
                           placeholder="Serviços oferecidos pelo equipamento"
          />

        </b-form-group>
        <b-form-group id="equipment-applications"
                      label="Aplicações:"
                      label-for="aplicacoes-do-equipamento">
          <b-form-textarea id="aplications"
                           v-model="form.equipment_applications"
                           :rows="2"
                           :max-rows="4"
                           optional
                           placeholder="Aplicações do equipamento"
          />
        </b-form-group>
        <b-form-group id="equipment-rules"
                      label="Regras:"
                      label-for="regras-do-equipamento">
          <b-form-textarea id="rules"
                           v-model="form.equipment_rules"
                           :rows="2"
                           :max-rows="4"
                           optional
                           placeholder="Regras de uso Equipamento"
          />
        </b-form-group>
      </b-card>
      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Horário de Uso
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Horário de uso do equipamento para cada dia da semana. <br>
            Caso o equipamento não possa ser usado em um determinado dia, deixe o campo em branco
          </p>
        </div>
        <b-form-group id="monday_attendance_time"
                      label="Segunda-feira:"
                      label-for="horario-uso-segunda">
          <b-form-input id="monday-time"
                        v-model="form.monday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="tuesday_attendance_time"
                      label="Terça-feira:"
                      label-for="horario-uso-terca">
          <b-form-input id="tuesday-time"
                        v-model="form.tuesday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="wednesday_attendance_time"
                      label="Quarta-feira:"
                      label-for="horario-uso-quarta">
          <b-form-input id="wednesday-time"
                        v-model="form.wednesday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="thursday_attendance_time"
                      label="Quinta-feira:"
                      label-for="horario-uso-quinta">
          <b-form-input id="thursday-time"
                        v-model="form.thursday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="friday_attendance_time"
                      label="Sexta-feira:"
                      label-for="horario-uso-sexta">
          <b-form-input id="friday-time"
                        v-model="form.friday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="saturday_attendance_time"
                      label="Sábado:"
                      label-for="horario-uso-sabado">
          <b-form-input id="saturday-time"
                        v-model="form.saturday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
        <b-form-group id="sunday_attendance_time"
                      label="Domingo:"
                      label-for="horario-uso-domingo">
          <b-form-input id="sunday-time"
                        v-model="form.sunday_attendance_time"
                        type="text"
                        optional
                        placeholder="Ex: 9:00 - 12:00 / 14:00 - 18:00"/>
        </b-form-group>
      </b-card>
      <b-row>
        <b-col sm="12" md="4" offset-md="8">
          <b-button v-if="!submit_success" class="btn-block" type="submit">Enviar</b-button>
        </b-col>
      </b-row>     
    </b-form>
  </div>
</template>

<script>
import locaisUsp from "static/unidades-departamentos.json";
export default {
  data() {
    return {
      submit_success: false,
      already_submit: false,
      submit_message_status: "",
      sub_color: "",
      dismissSecs: 10,
      dismissCountDown: 0,
      error_cause: "",
      departamentos: [],
      unidades: [],
      form: {
        equipment_name: null,
        equipment_english_name: null,
        equipment_presentation: null,
        equipment_brand: null,
        equipment_model: null,
        equipment_patrimony_number: null,
        equipment_acquisition_year: null,
        researcher_unit: null,
        researcher_USP_number: null,
        researcher_name: null,
        researcher_email: null,
        administrator_is_researcher: false,
        administrator_unit: null,
        administrator_USP_number: null,
        administrator_name: null,
        administrator_email: null,
        central_name: null,
        equipment_unit: null,
        equipment_department: null,
        equipment_address: null,
        equipment_address_number: null,
        equipment_address_complement: null,
        equipment_description: null,
        equipment_english_description: null,
        equipment_offered_services: null,
        equipment_applications: null,
        equipment_rules: null,
        monday_attendance_time: null,
        tuesday_attendance_time: null,
        wednesday_attendance_time: null,
        thursday_attendance_time: null,
        friday_attendance_time: null,
        saturday_attendance_time: null,
        sunday_attendance_time: null
      }
    };
  },
  beforeCreate: async function() {
    try {
      //Get all units
      let response = await this.$axios.$get("unit/");
      response.data.forEach(unit => this.unidades.push(unit.name));
    } catch (e) {
      this.unidades.splice(0, this.unidades.length);
      this.unidades.lenght = 0;
    }
    try {
      //Get the central name
      const central_response = await this.$axios.$get(
        "central/" + this.$route.query.central_id
      );
      this.form.central_name = central_response.name;
    } catch (e) {
      console.log(e);
    }
  },
  methods: {
    async onSubmit(evt) {
      evt.preventDefault();
      try {
        const result = await this.$axios.$post("equipment/", this.form);
        this.submit_message_status =
          "As informações do Equipamento foram preenchidas com sucesso!";
        this.submit_success = true;
        this.already_submit = true;
        this.sub_color = "success";
      } catch (e) {
        this.submit_message_status =
          "Erro no cadastro do Equipamento. Tente novamente!";
        this.submit_success = false;
        this.already_submit = true;
        this.sub_color = "danger";
        this.showAlert();
        if (e.response.status == 409) {
          this.error_cause = "Motivo: " + e.response.data.message;
        }
      }
    },
    async getAllUnits() {
      try {
        let response = await this.$axios.$get("unit/");
        response.data.forEach(unit => this.unidades.push(unit.name));
      } catch (e) {
        this.unidades.splice(0, this.unidades.length);
        this.unidades.lenght = 0;
      }
    },
    async getAllDepartments() {
      try {
        this.departamentos.splice(0, this.departamentos.length);
        this.departamentos.lenght = 0;
        let response = await this.$axios.$get(
          "unit/" + this.form.equipment_unit + "/departments"
        );
        response.forEach(department =>
          this.departamentos.push(department.department_name)
        );
      } catch (e) {
        this.departamentos.splice(0, this.departamentos.length);
        this.departamentos.lenght = 0;
        this.departamentos.push(this.form.equipment_unit);
      }
    },
    countDownChanged(dismissCountDown) {
      this.dismissCountDown = dismissCountDown;
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    redirectToCentral() {
      console.log("/central/" + this.$route.query.central_id);
      this.$router.push("/central/" + this.$route.query.central_id);
    }
  }
};
</script>


<style>
.btn-block {
  margin-top: 1em;
  margin-bottom: 1em;
  background-color: #fcb421;
}

.btn-block:hover {
  background-color: #ecbb5b;
}

.form-title {
  font-size: 20px;
}

.form-subtitle {
  font-size: 15px;
}

.section-title {
  font-size: 30px;
}

.section-separator {
  border: 1px solid;
}

.submit-message {
  position: fixed;
  width: 49%;
  margin: auto;
  text-align: center;
  vertical-align: center;
  z-index: 10;
}
</style>
